void SetupSetAddr() {
  unsigned int TrueAddress = dmxaddress - 3;
  
  OPMode = OP_MODE_SET_ADDR;
  UIMode = UI_MODE_SET_ADDR;
  SetAddrDigit = 2;  // Start with 100s
  SetBlinkDigit(SetAddrDigit);
  Addr1s = TrueAddress % 10;
  Addr10s = (TrueAddress / 10) % 10;
  Addr100s = TrueAddress / 100;
  SetupSetAddrDisplay(Addr100s, Addr10s, Addr1s);
  
  // Get the current potentiometer "digit" value for detecting changes for newly selected digits
  PrevPotDigit = GetPotDigit();
}


void EvalOpSetAddr() {
  // Evaluate digit value change from pot input
  byte CurPotDigit = GetPotDigit();
  if (CurPotDigit != PrevPotDigit) {
    // Update display and working address
    switch (SetAddrDigit) {
      case 0:
        Addr1s = CurPotDigit;
        break;
      case 1:
        Addr10s = CurPotDigit;
        break;
      case 2:
        Addr100s = CurPotDigit;
    }
    SetAddrDigitDisplay(SetAddrDigit, CurPotDigit);
    PrevPotDigit = CurPotDigit;
  }
}


void EvalUiSetAddr() {
  // Look for button presses
  if (ButtonPressShort) {
    // Select the next digit
    if (SetAddrDigit == 0) {
      SetAddrDigit = 2;
    } else {
      SetAddrDigit--;
    }
    SetBlinkDigit(SetAddrDigit);
  } else if (ButtonPressLong) {
    // Store our new address (ensure it's legal)
    dmxaddress = ((Addr100s * 100) + (Addr10s * 10) + Addr1s);
    if (dmxaddress == 0) {
      dmxaddress = 1;
    } else if (dmxaddress > MAX_DMX_ADDR) {
      dmxaddress = MAX_DMX_ADDR;
    }
    dmxaddress += 3;  // account for the dmx receiver
    StoreDmxAddress(dmxaddress);
    
    // Move to DMX mode
    SetupDMX();
    UIMode = UI_MODE_DMX;
    SetupDmxDisplay();
  }
}
