void EvalLogic () {
  // Evaluate the operating logic
  switch (OPMode) {
    // case OP_MODE_DMX is evaluated directly in the main loop for performance reasons
      
    case OP_MODE_SET_ADDR:
      EvalOpSetAddr();
      break;
      
    case OP_MODE_PROG_1:
      EvalOpProg1();
      break;
      
    case OP_MODE_PROG_2:
      EvalOpProg2();
      break;

    case OP_MODE_PROG_3:
      EvalOpProg3();
      break;

    case OP_MODE_PROG_4:
      EvalOpProg4();
  }
  
  // Evaluate the user interface logic  
  switch (UIMode) {
    case UI_MODE_DMX:
      EvalUiDMX();
      break;
      
    case UI_MODE_SET_ADDR:
      EvalUiSetAddr();
      break;

    case UI_MODE_PROG_1:
      EvalUiProg1();
      break;

    case UI_MODE_PROG_2:
      EvalUiProg2();
      break;

    case UI_MODE_PROG_3:
      EvalUiProg3();
      break;

    case UI_MODE_PROG_4:
      EvalUiProg4();
      break;
  }
  
  // Evaluate the mode change logic for mode storage in EEPROM
  EvalModeChange();
}


void SetPWM(byte r, byte g, byte b) {
//  cli();
  analogWrite(PWM_RED, r);
  analogWrite(PWM_GREEN, g);
  analogWrite(PWM_BLUE, b);
//  sei();
}
